/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.admin.reports.model;

import com.google.api.client.json.GenericJson;

/**
 * JSON template for a collection of usage reports.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Admin Reports API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class UsageReports extends GenericJson {

  /**
   * The kind of object.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String kind;

  /**
   * Token for retrieving the next page
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String nextPageToken;

  /**
   * Various application parameter records.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<UsageReport> usageReports;

  static {
    // hack to force ProGuard to consider UsageReport used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(UsageReport.class);
  }

  /**
   * Warnings if any.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Warnings> warnings;

  static {
    // hack to force ProGuard to consider Warnings used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(Warnings.class);
  }

  /**
   * The kind of object.
   * The value returned may be {@code null}.
   */
  public String getKind() {
    return kind;
  }

  /**
   * The kind of object.
   * The value set may be {@code null}.
   */
  public UsageReports setKind(String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Token for retrieving the next page
   * The value returned may be {@code null}.
   */
  public String getNextPageToken() {
    return nextPageToken;
  }

  /**
   * Token for retrieving the next page
   * The value set may be {@code null}.
   */
  public UsageReports setNextPageToken(String nextPageToken) {
    this.nextPageToken = nextPageToken;
    return this;
  }

  /**
   * Various application parameter records.
   * The value returned may be {@code null}.
   */
  public java.util.List<UsageReport> getUsageReports() {
    return usageReports;
  }

  /**
   * Various application parameter records.
   * The value set may be {@code null}.
   */
  public UsageReports setUsageReports(java.util.List<UsageReport> usageReports) {
    this.usageReports = usageReports;
    return this;
  }

  /**
   * Warnings if any.
   * The value returned may be {@code null}.
   */
  public java.util.List<Warnings> getWarnings() {
    return warnings;
  }

  /**
   * Warnings if any.
   * The value set may be {@code null}.
   */
  public UsageReports setWarnings(java.util.List<Warnings> warnings) {
    this.warnings = warnings;
    return this;
  }

  /**
   * Model definition for UsageReportsWarnings.
   */
  public static final class Warnings extends GenericJson {

    /**
     * Machine readable code / warning type.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private String code;

    /**
     * Key-Value pairs to give detailed information on the warning.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.util.List<Data> data;

    static {
      // hack to force ProGuard to consider Data used, since otherwise it would be stripped out
      // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
      com.google.api.client.util.Data.nullOf(Data.class);
    }

    /**
     * Human readable message for the warning.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private String message;

    /**
     * Machine readable code / warning type.
     * The value returned may be {@code null}.
     */
    public String getCode() {
      return code;
    }

    /**
     * Machine readable code / warning type.
     * The value set may be {@code null}.
     */
    public Warnings setCode(String code) {
      this.code = code;
      return this;
    }

    /**
     * Key-Value pairs to give detailed information on the warning.
     * The value returned may be {@code null}.
     */
    public java.util.List<Data> getData() {
      return data;
    }

    /**
     * Key-Value pairs to give detailed information on the warning.
     * The value set may be {@code null}.
     */
    public Warnings setData(java.util.List<Data> data) {
      this.data = data;
      return this;
    }

    /**
     * Human readable message for the warning.
     * The value returned may be {@code null}.
     */
    public String getMessage() {
      return message;
    }

    /**
     * Human readable message for the warning.
     * The value set may be {@code null}.
     */
    public Warnings setMessage(String message) {
      this.message = message;
      return this;
    }

    /**
     * Model definition for UsageReportsWarningsData.
     */
    public static final class Data extends GenericJson {

      /**
       * Key associated with a key-value pair to give detailed information on the warning.
       * The value may be {@code null}.
       */
      @com.google.api.client.util.Key
      private String key;

      /**
       * Value associated with a key-value pair to give detailed information on the warning.
       * The value may be {@code null}.
       */
      @com.google.api.client.util.Key
      private String value;

      /**
       * Key associated with a key-value pair to give detailed information on the warning.
       * The value returned may be {@code null}.
       */
      public String getKey() {
        return key;
      }

      /**
       * Key associated with a key-value pair to give detailed information on the warning.
       * The value set may be {@code null}.
       */
      public Data setKey(String key) {
        this.key = key;
        return this;
      }

      /**
       * Value associated with a key-value pair to give detailed information on the warning.
       * The value returned may be {@code null}.
       */
      public String getValue() {
        return value;
      }

      /**
       * Value associated with a key-value pair to give detailed information on the warning.
       * The value set may be {@code null}.
       */
      public Data setValue(String value) {
        this.value = value;
        return this;
      }

    }
  }

}
